#include<stdio.h>
#include <reg51.h>
typedef unsigned char Uchar ;
typedef unsigned int  Uint ;
typedef unsigned long Ulong ;
typedef unsigned char uchar ;
typedef unsigned int  uint ;
typedef unsigned long ulong ;
#define   TR0_RELOAD (-921)
Uchar j,temp,*str,flag;
Uint i,stcol,encol;

Uint  count,time;

sbit lcd_rs = P2^4;
sbit lcd_en = P2^5;

void init_hw(void)
{

	TMOD = 0x21;
	TH0  = (Uchar)(TR0_RELOAD>>8);
	TL0  = (Uchar)TR0_RELOAD;
   	TR0  = 1;
	IE   = 0x82; 								// IE: timer0
   	TR1  = 0;
}

void delayms(Uint n)
{
	n = count + n;
   while (n != count);
}

void timer0(void)
interrupt 1 using 1
{
  	count++;
	TH0 = (Uchar)(TR0_RELOAD>>8);
	TL0 = (Uchar)TR0_RELOAD;				 // reload
} 

void execute_lcd(void)
{	   
		lcd_rs=0; 		                    // command
		delayms(5);
		lcd_en=1;
		delayms(8);
		lcd_en=0; 		
		delayms(5);
        lcd_rs=1; 		
}   

void write_lcd(void)
{	
		lcd_en=1;
 		delayms(8);
		lcd_en=0;
} 	

void init_lcd(void)
{
		P0=0x38;
 		execute_lcd();
		P0=0x38;
		execute_lcd();
		P0=0x38;
		execute_lcd();
		P0=0x80;
 		execute_lcd();
		P0=0x80;
		execute_lcd();
		P0=0x80;
		execute_lcd();
		P0=0x01;
		execute_lcd();
		P0=0x01;
		execute_lcd();
		P0=0x06;
		execute_lcd();
		P0=0x06;
		execute_lcd();
		P0=0x0c;
		execute_lcd();
		P0=0x0c;
		execute_lcd();
		P0=0x0c;
	}

void write_data(Uchar *str,Uint stcol, Uint encol)
{
	if(stcol <= 15)
		P0 = 0x80+stcol;
	else
	{
		stcol = stcol-16;
		P0 = 0x0c0 + stcol;

	}
 		execute_lcd();
		for(;stcol<=encol;stcol++)
	  {
	    P0 = str[stcol];
		write_lcd();
	  }
}

void main(void)
{
		init_hw();
		init_lcd();
		flag=0;
		write_data("ni2 designs,Pune",0,15);
		write_data("LCD Test Program",16,31);
		while(flag==0)
		{}

 }



	
	



